package _PonPhone;

#--------------------------------------------------------------------------
#
# _PonPhone.pm, (C)Copyright 2003 OGATA, Tetsuji
#
# PerlModule͏N쐬܂B
# 쌠͏Nɑ܂B
# 쌠폜ȂAgpEĔzz͂ȂړIłĂARɍs
# Ă܂܂B
# gpEĔzz̍ۂɉςKvȏꍇ́Aωӏmɂ킩悤ɂAł
# t@C(W[)ύXĂB
#
# CGIۂ  http://specters.net/cgipon/  N  cgipon@specters.net
#
#--------------------------------------------------------------------------

my $VERSION = 0.3.2;	# last modified 2003/06/08

#==========================================================================
#	[ API ]
#==========================================================================
#	new( METHOD, SET )
#	print_all()
#	print_location( URL )
#	push_text( SERVICE, POSITION, STRING, COLOR )
#	push_anchor( SERVICE, POSITION, STRING, URL, KEY )
#	push_mlink( SERVICE, POSITION, STRING, MAIL, KEY )
#	push_plink( SERVICE, POSITION, STRING, PHONE, KEY )
#	push_image( SERVICE, POSITION, URL )
#	push_hr( SERVICE )
#	push_title( SERVICE, POSITION, STRING, COLOR )
#	set_page_attribute( TITLE, BACKGROUND, BGCOLOR,
#											TEXTCOLOR, LINKCOLOR, COOKIE )
#	is_mobile()
#	get_ml()
#	get_service()
#	get_service_char()
#==========================================================================

#==========================================================================
#	[ ϐ̐錾 ]
#==========================================================================
my $UserAgent;
my @UserAgent;

#==========================================================================
#	[ 萔̒` ]
#==========================================================================

# }[NAbv
#	'HTML'
#	'CHTML'
#	'HDML'
#	'ONC'
#	'XHTML_AU'

my %SERVICE_CHAR = (
	'UNDEF'     => 'p',
	'AIRHPHONE' => 'a',
	'DOTI'      => 'd',
	'EZWEB'     => 'e',
	'HLINK'     => 'h',
	'IMODE'     => 'i',
	'JSKY'      => 'j',
	'LMODE'     => 'l',
	'PDA'       => 'x',
	);
my $SERVICE_ALL = 'adehijlpx';


# R[h
my $CRLF = "\x0d\x0a";

#--------------------------------------------------------------------------
#	֐	new
#	@\	IuWFNg̐
#		METHOD:	[ʕ@('host' or 'ua')
#			SET:	IuWFNgɎݒ̃nbV
#--------------------------------------------------------------------------
sub new
{
	my $type = shift;
	my $this = {};
	bless $this, $type;
	$this->_init(@_);
	return $this;
}

#--------------------------------------------------------------------------
#	֐	print_all
#	@\	o
#		Ȃ
#--------------------------------------------------------------------------
sub print_all
{
	my $this = shift;

	if ( $this->{ML} eq 'HTML' ) {
		$this->_set_content_html();
		$this->_print_http_header_html();
	} elsif ( $this->{ML} eq 'CHTML' ) {
		$this->_set_content_chtml();
		$this->_print_http_header_html();
	} elsif ( $this->{ML} eq 'HDML' ) {
		$this->_set_content_hdml();
		$this->_print_hdtp_header();
	} elsif ( $this->{ML} eq 'ONC' ) {
		$this->_set_content_onc();
		$this->_print_http_header_onc();
	} elsif ( $this->{ML} eq 'XHTML_AU' ) {
		$this->_set_content_pseudo_xhtml_au();
		$this->_print_http_header_xhtml();
	}
	print $this->{CONTENT};
}

#--------------------------------------------------------------------------
#	֐	print_location
#	@\	y[W΂
#		URL:	΂
#	Ԓl	^l:	I
#			Ul:	ُI(URL̃tH[}bgG[Ȃ)
#--------------------------------------------------------------------------
sub print_location
{
	my $this = shift;

	my %param = (
		URL => '',
		@_,
		);

	my $ret;
	if ( $param{URL} =~ /^http:\/\// ) {
		$ret = $this->_print_location_header(%param);
	} else {
		$ret = $this->_print_location_file(%param);
	}
	return $ret;
}

#--------------------------------------------------------------------------
#	֐	push_text
#	@\	eLXg̒ǉ
#		SERVICE:	ΏۃT[rX(adehijlpx)
#			POSITION:	CAEgw('l' or 'c' or 'r' or 's' or '^')
#			STRING:		\i[ϐ̃t@X
#			COLOR:		\F
#--------------------------------------------------------------------------
sub push_text
{
	my $this = shift;

	my %param = (
		SERVICE => $SERVICE_ALL,
		POSITION => 'l',
		STRING => \'',
		COLOR => '',
		@_,
		);

	$param{SERVICE} !~ /$SERVICE_CHAR{$this->{SERVICE}}/i and return;
	${$param{STRING}} eq '' and return;

	if ( $this->{ML} eq 'HTML' ) {
		$this->_push_text_html(@_);
	} elsif ( $this->{ML} eq 'CHTML' ) {
		$this->_push_text_chtml(@_);
	} elsif ( $this->{ML} eq 'HDML' ) {
		$this->_push_text_hdml(@_);
	} elsif ( $this->{ML} eq 'ONC' ) {
		$this->_push_text_onc(@_);
	} elsif ( $this->{ML} eq 'XHTML_AU' ) {
		$this->_push_text_pseudo_xhtml_au(@_);
	}
}

#--------------------------------------------------------------------------
#	֐	push_anchor
#	@\	AJ[̒ǉ
#		SERVICE:	ΏۃT[rX(adehijlpx)
#			POSITION:	CAEgw('l' or 'c' or 'r' or 's' or '^')
#			STRING:		\i[ϐ̃t@X
#			URL:		URL
#			KEY:		ANZXL[
#--------------------------------------------------------------------------
sub push_anchor
{
	my $this = shift;

	my %param = (
		SERVICE => $SERVICE_ALL,
		POSITION => 'l',
		STRING => \'',
		URL => '',
		KEY => '',
		@_,
		);

	$param{SERVICE} !~ /$SERVICE_CHAR{$this->{SERVICE}}/i and return;
	${$param{STRING}} eq '' and return;
	$param{URL} eq '' and return;

	if ( $this->{ML} eq 'HTML' ) {
		$this->_push_anchor_html(@_);
	} elsif ( $this->{ML} eq 'CHTML' ) {
		$this->_push_anchor_chtml(@_);
	} elsif ( $this->{ML} eq 'HDML' ) {
		$this->_push_anchor_hdml(@_);
	} elsif ( $this->{ML} eq 'ONC' ) {
		$this->_push_anchor_onc(@_);
	} elsif ( $this->{ML} eq 'XHTML_AU' ) {
		$this->_push_anchor_pseudo_xhtml_au(@_);
	}
}

#--------------------------------------------------------------------------
#	֐	push_mlink
#	@\	[N̒ǉ
#		SERVICE:	ΏۃT[rX(adehijlpx)
#			POSITION:	CAEgw('l' or 'c' or 'r' or 's' or '^')
#			STRING:		\i[ϐ̃t@X
#			MAIL:		[AhX
#			KEY:		ANZXL[
#--------------------------------------------------------------------------
sub push_mlink
{
	my $this = shift;

	my %param = (
		SERVICE => $SERVICE_ALL,
		POSITION => 'l',
		STRING => \'',
		MAIL => '',
		KEY => '',
		@_,
		);

	$param{SERVICE} !~ /$SERVICE_CHAR{$this->{SERVICE}}/i and return;
	${$param{STRING}} eq '' and return;
	$param{MAIL} eq '' and return;

	if ( $this->{ML} eq 'HTML' ) {
		$this->_push_mlink_html(@_);
	} elsif ( $this->{ML} eq 'CHTML' ) {
		$this->_push_mlink_chtml(@_);
	} elsif ( $this->{ML} eq 'HDML' ) {
		$this->_push_mlink_hdml(@_);
	} elsif ( $this->{ML} eq 'ONC' ) {
		$this->_push_mlink_onc(@_);
	} elsif ( $this->{ML} eq 'XHTML_AU' ) {
		$this->_push_mlink_pseudo_xhtml_au(@_);
	}
}

#--------------------------------------------------------------------------
#	֐	push_plink
#	@\	dbN̒ǉ
#		SERVICE:	ΏۃT[rX(adehijlpx)
#			POSITION:	CAEgw('l' or 'c' or 'r' or 's' or '^')
#			STRING:		\i[ϐ̃t@X
#			PHONE:		URL
#			KEY:		ANZXL[
#--------------------------------------------------------------------------
sub push_plink
{
	my $this = shift;

	my %param = (
		SERVICE => $SERVICE_ALL,
		POSITION => 'l',
		STRING => \'',
		PHONE => '',
		KEY => '',
		@_,
		);

	$param{SERVICE} !~ /$SERVICE_CHAR{$this->{SERVICE}}/i and return;
	${$param{STRING}} eq '' and return;
	$param{PHONE} eq '' and return;

	if ( $this->{ML} eq 'HTML' ) {
		$this->_push_plink_html(@_);
	} elsif ( $this->{ML} eq 'CHTML' ) {
		$this->_push_plink_chtml(@_);
	} elsif ( $this->{ML} eq 'HDML' ) {
		$this->_push_plink_hdml(@_);
	} elsif ( $this->{ML} eq 'ONC' ) {
		$this->_push_plink_onc(@_);
	} elsif ( $this->{ML} eq 'XHTML_AU' ) {
		$this->_push_plink_pseudo_xhtml_au(@_);
	}
}

#--------------------------------------------------------------------------
#	֐	push_image
#	@\	摜̒ǉ
#		SERVICE:	ΏۃT[rX(adehijlpx)
#			POSITION:	CAEgw('l' or 'c' or 'r' or 's' or '^')
#			STRING:		\i[ϐ̃t@X
#			URL:		URL
#--------------------------------------------------------------------------
sub push_image
{
	my $this = shift;

	my %param = (
		SERVICE => $SERVICE_ALL,
		POSITION => 'l',
		STRING => \'',
		URL => '',
		@_,
		);

	$param{SERVICE} !~ /$SERVICE_CHAR{$this->{SERVICE}}/i and return;
	$param{URL} eq '' and return;

	if ( $this->{ML} eq 'HTML' ) {
		$this->_push_image_html(@_);
	} elsif ( $this->{ML} eq 'CHTML' ) {
		$this->_push_image_chtml(@_);
	} elsif ( $this->{ML} eq 'HDML' ) {
		$this->_push_image_hdml(@_);
	} elsif ( $this->{ML} eq 'ONC' ) {
		$this->_push_image_onc(@_);
	} elsif ( $this->{ML} eq 'XHTML_AU' ) {
		$this->_push_image_pseudo_xhtml_au(@_);
	}
}

#--------------------------------------------------------------------------
#	֐	push_hr
#	@\	̒ǉ
#		SERVICE:	ΏۃT[rX(adehijlpx)
#--------------------------------------------------------------------------
sub push_hr
{
	my $this = shift;

	my %param = (
		SERVICE => $SERVICE_ALL,
		@_,
		);

	$param{SERVICE} !~ /$SERVICE_CHAR{$this->{SERVICE}}/i and return;

	if ( $this->{ML} eq 'HTML' ) {
		$this->_push_hr_html();
	} elsif ( $this->{ML} eq 'CHTML' ) {
		$this->_push_hr_chtml();
	} elsif ( $this->{ML} eq 'HDML' ) {
		$this->_push_hr_hdml();
	} elsif ( $this->{ML} eq 'ONC' ) {
		$this->_push_hr_onc();
	} elsif ( $this->{ML} eq 'XHTML_AU' ) {
		$this->_push_hr_pseudo_xhtml_au();
	}
}

#--------------------------------------------------------------------------
#	֐	push_title
#	@\	^Cg̒ǉ
#		SERVICE:	ΏۃT[rX(adehijlpx)
#			POSITION:	CAEgw('l' or 'c' or 'r' or 's' or '^')
#			STRING:		\i[ϐ̃t@X
#			COLOR:		\F
#--------------------------------------------------------------------------
sub push_title
{
	my $this = shift;

	my %param = (
		SERVICE => $SERVICE_ALL,
		POSITION => 'c',
		STRING => \'',
		COLOR => '',
		@_,
		);

	$this->set_page_attribute( TITLE => ${$param{STRING}} );
	$this->{BI}->{AUTO_TITLE} or $this->push_text(%param);
}

#--------------------------------------------------------------------------
#	֐	set_page_attribute
#	@\	y[W̐ݒ
#		TITLE:		^Cg
#			BACKGROUND:	wi摜
#			BGCOLOR:	wiF
#			TEXTCOLOR:	F
#			LINKCOLOR:	NF
#			COOKIE:		NbL[̕i[ϐ̃t@X
#--------------------------------------------------------------------------
sub set_page_attribute
{
	my $this = shift;

	%{$this->{PA}} = (
		TITLE => '',
		BACKGROUND => '',
		BGCOLOR => '',
		TEXTCOLOR => '',
		LINKCOLOR => '',
		COOKIE => \'',
		%{$this->{PA}},
		@_,
		);
}

#--------------------------------------------------------------------------
#	֐	is_mobile
#	@\	P[^C() or LmodeǂԂ
#		Ȃ
#--------------------------------------------------------------------------
sub is_mobile
{
	my $this = shift;

	if ( $this->{SERVICE} ne 'UNDEF' ) {
		return 1;
	} else {
		return 0;
	}
}

sub get_ml
{
	my $this = shift;

	return $this->{ML};
}

sub get_service
{
	my $this = shift;

	return $this->{SERVICE};
}

sub get_service_char
{
	my $this = shift;

	return $SERVICE_CHAR{$this->{SERVICE}};
}


#==========================================================================
#	[ HTML쐬 ]
#==========================================================================
sub _set_content_html
{
	my $this = shift;
	$this->_set_content_chtml(@_);
}

sub _push_text_html
{
	my $this = shift;
	$this->_push_text_chtml(@_);
}

sub _push_anchor_html
{
	my $this = shift;
	$this->_push_anchor_chtml(@_);
}

sub _push_mlink_html
{
	my $this = shift;
	$this->_push_mlink_chtml(@_);
}

sub _push_plink_html
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		PHONE => '',
		@_,
		);

	$this->_push_position_html($param{POSITION});
	$this->_trans_string_html($param{STRING});
	push(@{$this->{BODY}}, qq(${$param{STRING}}($param{PHONE})));
}

sub _push_image_html
{
	my $this = shift;
	$this->_push_image_chtml(@_);
}

sub _push_hr_html
{
	my $this = shift;
	$this->_push_hr_chtml(@_);
}

#==========================================================================
#	[ CHTML쐬 ]
#==========================================================================
sub _set_content_chtml
{
	my $this = shift;

	my (@header, $footer);
	push(@header, qq(<HTML><HEAD>));
	if ( $this->{PA}->{TITLE} ) {
		$this->_trans_string_html(\$this->{PA}->{TITLE});
		push(@header, qq(<TITLE>$this->{PA}->{TITLE}</TITLE>));
	}
	push(@header, qq(</HEAD><BODY));
	$this->{PA}->{BACKGROUND}
		and push(@header, qq( background="$this->{PA}->{BACKGROUND}"));
	$this->{PA}->{BGCOLOR}
		and push(@header, qq( bgcolor="$this->{PA}->{BGCOLOR}"));
	$this->{PA}->{TEXTCOLOR}
		and push(@header, qq( text="$this->{PA}->{TEXTCOLOR}"));
	$this->{PA}->{LINKCOLOR}
		and push(@header, qq( link="$this->{PA}->{LINKCOLOR}"));
	push(@header, qq(>\n));

	$footer = "</BODY></HTML>\n";

	$this->{CONTENT}
		= join('', @header, @{$this->{BODY}}, $this->{KET}, $footer);
}

sub _push_text_chtml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		COLOR => '',
		@_,
		);

	$this->_push_position_html($param{POSITION});
	$this->_trans_string_html($param{STRING});
	if ( $param{COLOR} ) {
		push(@{$this->{BODY}},
			qq(<FONT color=$param{COLOR}>${$param{STRING}}</FONT>));
	} else {
		push(@{$this->{BODY}}, ${$param{STRING}});
	}
}

sub _push_anchor_chtml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		URL => '',
		KEY => '',
		@_,
		);

	$this->_push_position_html($param{POSITION});
	$this->_trans_string_html($param{STRING});
	if ( $param{KEY} && $this->{BI}->{KEY}->[$param{KEY}] ) {
		push(@{$this->{BODY}},
			$this->{BI}->{KEY}->[$param{KEY}],
			qq(<A href="$param{URL}" $this->{BI}->{ADKEY}=$param{KEY}>),
			qq(${$param{STRING}}</A>)
		);
	} else {
		push(@{$this->{BODY}}, qq(<A href="$param{URL}">${$param{STRING}}</A>));
	}
}

sub _push_mlink_chtml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		MAIL => '',
		KEY => '',
		@_,
		);

	$this->_push_position_html($param{POSITION});
	$this->_trans_string_html($param{STRING});
	if ( $param{ADKEY} && $this->{BI}->{KEY}->[$param{KEY}] ) {
		push(@{$this->{BODY}},
			$this->{BI}->{KEY}->[$param{KEY}],
			qq(<A href="mailto:$param{MAIL}"),
			qq( $this->{BI}->{ADKEY}=$param{ADKEY}>),
			qq(${$param{STRING}}</A>)
		);
	} else {
		push(@{$this->{BODY}},
			qq(<A href="mailto:$param{MAIL}">${$param{STRING}}</A>));
	}
}

sub _push_plink_chtml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		PHONE => '',
		KEY => '',
		@_,
		);

	$this->_push_position_html($param{POSITION});
	$this->_trans_string_html($param{STRING});
	if ( $param{ADKEY} && $this->{BI}->{KEY}->[$param{KEY}] ) {
		push(@{$this->{BODY}},
			$this->{BI}->{KEY}->[$param{KEY}],
			qq(<A href="tel:$param{PHONE}"),
			qq( $this->{BI}->{ADKEY}=$param{ADKEY}>),
			qq(${$param{STRING}}</A>)
		);
	} else {
		push(@{$this->{BODY}},
			qq(<A href="tel:$param{PHONE}">${$param{STRING}}</A>));
	}
}

sub _push_image_chtml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		URL => '',
		@_,
		);

	$this->_push_position_html($param{POSITION});
	$this->_trans_string_html($param{STRING});
	$this->_trans_image_extension(\$param{URL});
	${$param{STRING}} =~ s/"/&quot;/g;
	push(@{$this->{BODY}}, qq(<IMG src="$param{URL}"));
	${$param{STRING}} and push(@{$this->{BODY}}, qq( alt="${$param{STRING}}"));
	push(@{$this->{BODY}}, qq(>));
}

sub _push_hr_chtml
{
	my $this = shift;

	push(@{$this->{BODY}}, $this->{KET}, qq(<HR>\n));
	$this->{KET} = '';
}

sub _push_position_html
{
	my $this = shift;
	my ($position) = @_;

	if ( $position eq 'l' ) {
		push(@{$this->{BODY}}, $this->{KET});
		$this->{KET} = "<BR>\n";
	} elsif ( $position eq 'c' ) {
		if ( $this->{KET} eq "</CENTER>\n" ) {
			push(@{$this->{BODY}}, "<BR>\n");
		} else {
			push(@{$this->{BODY}}, $this->{KET});
			push(@{$this->{BODY}}, '<CENTER>');
		}
		$this->{KET} = "</CENTER>\n";
	} elsif ( $position eq 'r' ) {
		if ( $this->{KET} eq "</DIV>\n" ) {
			push(@{$this->{BODY}}, "<BR>\n");
		} elsif ( $this->{KET} eq "<BR>\n" ) {
			push(@{$this->{BODY}}, '<DIV align=right>');
		} else {
			push(@{$this->{BODY}}, $this->{KET});
			push(@{$this->{BODY}}, '<DIV align=right>');
		}
		$this->{KET} = "</DIV>\n";
	} elsif ( $position eq 's' ) {
		if ( $this->{KET} eq "</MARQUEE>\n" ) {
			push(@{$this->{BODY}}, "<BR>\n");
		} else {
			push(@{$this->{BODY}}, $this->{KET});
			push(@{$this->{BODY}}, '<MARQUEE loop=4>');
		}
		$this->{KET} = "</MARQUEE>\n";
	} elsif ( $position eq '^' ) {
		;
	}
}


#==========================================================================
#	[ HDML쐬 ]
#==========================================================================
sub _set_content_hdml
{
	my $this = shift;

	my (@header, $footer);
	push(@header, qq(<HDML version=3.0 ttl=0 markable=true>\n));
	push(@header, qq(<DISPLAY name=top));
	if ( $this->{PA}->{TITLE} ) {
		$this->_trans_string_hdml(\$this->{PA}->{TITLE});
		$this->{PA}->{TITLE} =~ s/"/&quot;/g;
		push(@header, qq( title="$this->{PA}->{TITLE}"));
	}
	push(@header, qq(>\n$this->{PE}->{CARDACT}));

	$footer = $this->{PE}->{CARDKET} . "</HDML>\n";

	$this->{CONTENT}
		= join('', @header, @{$this->{BODY}}, $this->{KET}, $footer);
}

sub _push_text_hdml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		COLOR => '',
		@_,
		);

	$this->_push_position_hdml($param{POSITION});
	$this->_trans_string_hdml($param{STRING});
	push(@{$this->{BODY}}, ${$param{STRING}});
}

sub _push_anchor_hdml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		URL => '',
		KEY => '',
		@_,
		);

	$this->_push_position_hdml($param{POSITION});
	$this->_trans_string_hdml($param{STRING});
	if ( $param{KEY} ) {
		push(@{$this->{BODY}},
			qq(<A task=go dest="$param{URL}" accesskey=$param{KEY}>),
			qq(${$param{STRING}}</A>)
		);
	} else {
		push(@{$this->{BODY}},
			qq(<A task=go dest="$param{URL}">${$param{STRING}}</A>));
	}
}

sub _push_mlink_hdml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		MAIL => '',
		KEY => '',
		@_,
		);

	$this->_push_position_hdml($param{POSITION});
	$this->_trans_string_hdml($param{STRING});
	if ( $param{KEY} ) {
		push(@{$this->{BODY}},
			qq(<A task=go dest="mailto:$param{MAIL}"),
			qq( accesskey=$param{KEY}>),
			qq(${$param{STRING}}</A>)
		);
	} else {
		push(@{$this->{BODY}},
			qq(<A task=go dest="mailto:$param{MAIL}">),
			qq(${$param{STRING}}</A>)
		);
	}
}

sub _push_plink_hdml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		PHONE => '',
		KEY => '',
		@_,
		);

	$this->_push_position_hdml($param{POSITION});
	$this->_trans_string_hdml($param{STRING});
	if ( $param{KEY} ) {
		push(@{$this->{BODY}},
			qq(<A task=call number="$param{PHONE}" accesskey=$param{KEY}>),
			qq(${$param{STRING}}</A>)
		);
	} else {
		push(@{$this->{BODY}},
			qq(<A task=call number="$param{PHONE}">${$param{STRING}}</A>));
	}
}

sub _push_image_hdml
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		URL => '',
		@_,
		);

	$this->_push_position_hdml($param{POSITION});
	$this->_trans_string_hdml($param{STRING});
	$this->_trans_image_extension(\$param{URL});
	${$param{STRING}} =~ s/"/&quot;/g;
	push(@{$this->{BODY}}, qq(<IMG src="$param{URL}"));
	${$param{STRING}} and push(@{$this->{BODY}}, qq( alt="${$param{STRING}}"));
	push(@{$this->{BODY}}, qq(>));
}

sub _push_hr_hdml
{
	my $this = shift;

	push(@{$this->{BODY}}, $this->{KET}, $this->{BI}->{HR});
	$this->{KET} = '';
}

sub _push_position_hdml
{
	my $this = shift;
	my ($position) = @_;

	if ( $position eq 'l' ) {
		push(@{$this->{BODY}}, $this->{KET});
		$this->{KET} = "<BR>\n";
	} elsif ( $position eq 'c' ) {
		push(@{$this->{BODY}}, $this->{KET});
		push(@{$this->{BODY}}, '<CENTER>');
		$this->{KET} = "<BR>\n";
	} elsif ( $position eq 'r' ) {
		push(@{$this->{BODY}}, $this->{KET});
		push(@{$this->{BODY}}, '<RIGHT>');
		$this->{KET} = "<BR>\n";
	} elsif ( $position eq 's' ) {
		if ( $this->{KET} eq "\n<WRAP>" ) {
			push(@{$this->{BODY}}, "<BR>\n");
		} else {
			push(@{$this->{BODY}}, $this->{KET});
			push(@{$this->{BODY}}, '<LINE>');
		}
		$this->{KET} = "\n<WRAP>";
	} elsif ( $position eq '^' ) {
		;
	}
}


#==========================================================================
#	[ ONC쐬 ]
#==========================================================================
sub _set_content_onc
{
	my $this = shift;

	my @header;
	push(@header, @{$this->{PE}->{ADD}});
	$this->{BI}->{FROM} =~ s/^http://;
	push(@header, qq(From: $this->{BI}->{FROM}\n));
	$this->_trans_string_onc(\$this->{PA}->{TITLE});
	push(@header, qq(Subject: $this->{PA}->{TITLE}\n));
	$this->{PE}->{INPUT}
		and push(@header, qq(X-PmailDX-Input: $this->{PE}->{INPUT}\n));
	$this->{PE}->{REQMAIL}
		and push(@header, qq(X-PmailDX-CTRL: $this->{PE}->{REQMAIL}\n));
	push(@header, qq(Content-Type: Text/X-PmailDX\n\n));
	push(@header, @{$this->{PE}->{SEL}});
	if (($this->{BI}->{GI} >= 2) &&
		($this->{PA}->{BGCOLOR} || $this->{PA}->{TEXTCOLOR})) {
		push(@header, qq(<BODY));
		$this->{PA}->{TEXTCOLOR} =~ s/^#//;
		$this->{PA}->{TEXTCOLOR}
			and push(@header, qq(=$this->{PA}->{TEXTCOLOR}));
		$this->{PA}->{BGCOLOR} =~ s/^#//;
		$this->{PA}->{BGCOLOR}
			and push(@header, qq(;BG=$this->{PA}->{BGCOLOR}));
		push(@header, qq(>\n));
	}

	$this->{CONTENT}
		= join('', @header, @{$this->{BODY}}, $this->{KET});
}

sub _push_text_onc
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		COLOR => '',
		@_,
		);

	$this->_push_position_onc($param{POSITION}, length(${$param{STRING}}));
	$this->_trans_string_onc($param{STRING});

	if ( $param{COLOR} && $this->{BI}->{GI} >= 2 ) {
		$param{COLOR} =~ s/^#//;
		push(@{$this->{BODY}}, qq(<C=$param{COLOR}>${$param{STRING}}</C>));
	} else {
		push(@{$this->{BODY}}, ${$param{STRING}});
	}
}

sub _push_anchor_onc
{
	my $this = shift;
	my %param = (
		STRING => \'',
		URL => '',
		KEY => '',
		@_,
		POSITION => 'l'
		);

	$param{KEY} eq '' and $param{KEY} = $this->{PE}->{KEY}++;
	$param{URL} =~ s/^http://;

	$this->_push_position_onc($param{POSITION}, 0);
	$this->_trans_string_onc($param{STRING});
	push(@{$this->{PE}->{SEL}}, qq(<SEL=$param{KEY};$param{URL}>\n));
	${$this->{BODY}}[-1] =~ s/\n$//g;
	if ( $this->{PA}->{LINKCOLOR} && $this->{BI}->{GI} >= 2 ) {
		push(@{$this->{BODY}},
			qq(\n<C=$this->{PA}->{LINKCOLOR}>),
			qq($param{KEY}${$param{STRING}}</C>));
	} else {
		push(@{$this->{BODY}}, qq(\n$param{KEY}${$param{STRING}}));
	}
}

sub _push_mlink_onc
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		MAIL => '',
		KEY => '',
		@_,
		);

	$this->_push_position_onc($param{POSITION}, 0);
	$this->_trans_string_onc($param{STRING});
	push(@{$this->{BODY}}, "${$param{STRING}}(<#MAIL>$param{MAIL})");
}

sub _push_plink_onc
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		PHONE => '',
		KEY => '',
		@_,
		);

	$this->_push_position_onc($param{POSITION}, 0);
	$this->_trans_string_onc($param{STRING});
	push(@{$this->{BODY}}, "${$param{STRING}}(<#TELEPHONE>$param{PHONE})");
}

sub _push_image_onc
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		URL => '',
		@_,
		);

	$this->_push_position_onc($param{POSITION}, 0);
	$this->_trans_string_onc($param{STRING});
	$this->_trans_image_extension(\$param{URL});
	push(@{$this->{PE}->{ADD}},
		qq(X-PmailDX-CTRL-Append: Name="$param{URL}"\n));
	if ( $this->{BI}->{GI} >= 2 ) {
		push(@{$this->{BODY}}, qq(<IMG="$param{URL}">));
	} else {
		push(@{$this->{BODY}}, qq(}[${$param{STRING}}]));
	}
}

sub _push_hr_onc
{
	my $this = shift;

	push(@{$this->{BODY}}, $this->{KET}, $this->{BI}->{HR});
	$this->{KET} = '';
}

sub _push_position_onc
{
	my $this = shift;
	my ($position, $length) = @_;

	my $margin = 0;
	$length and $margin = ($this->{BI}->{TX} * 2) - $length;
	$margin < 0 and $margin = 0;

	if ( $position eq 'l' or $position eq 's') {
		$this->{KET} and push(@{$this->{BODY}}, $this->{KET});
		$this->{KET} = "\n";
	} elsif ( $position eq 'c' ) {
		$this->{KET} and push(@{$this->{BODY}}, $this->{KET});
		$margin /= 2;
		push(@{$this->{BODY}},
			'@' x ($margin / 2),
			' ' x ($margin % 2),
			);
		$this->{KET} = "\n";
	} elsif ( $position eq 'r' ) {
		$this->{KET} and push(@{$this->{BODY}}, $this->{KET});
		push(@{$this->{BODY}},
			'@' x ($margin / 2),
			' ' x ($margin % 2),
			);
		$this->{KET} = "\n";
	} elsif ( $position eq '^' ) {
		;
	}
}


#==========================================================================
#	[ Ȃ񂿂XHTML-MP(for AU)쐬 ]
#==========================================================================
sub _set_content_pseudo_xhtml_au
{
	my $this = shift;

	my (@header, $footer);
	if ( 0 ) {
		push(@header,
			qq(<?xml version="1.0" encoding="Shift_JIS"?>\n),
			qq(<!DOCTYPE html PUBLIC "-//OPENWAVE//DTD XHTML Mobile 1.0//EN"),
			qq( "http://www.openwave.com/DTD/xhtml-mobile10.dtd">\n),
			qq(<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="jp">\n)
			);
	} else {
		push(@header, qq(<html>\n));
	}
	if ( $this->{PA}->{TITLE} ) {
		$this->_trans_string_html(\$this->{PA}->{TITLE});
		push(@header, qq(<title>$this->{PA}->{TITLE}</title>\n));
	}
	if ($this->{PA}->{BGCOLOR} ||
		$this->{PA}->{TEXTCOLOR} ||
		$this->{PA}->{LINKCOLOR}) {
		push(@header, qq(<style>\n));
		if ($this->{PA}->{BGCOLOR} || $this->{PA}->{TEXTCOLOR}) {
			push(@header, qq(body {));
			$this->{PA}->{BGCOLOR}
				and push(@header,
					qq( background-color:$this->{PA}->{BGCOLOR};));
			$this->{PA}->{TEXTCOLOR}
				and push(@header, qq( color:$this->{PA}->{TEXTCOLOR};));
			push(@header, qq( }\n));
		}
		$this->{PA}->{LINKCOLOR}
			and push(@header, qq(a { color:$this->{PA}->{LINKCOLOR}; }\n));
		push(@header, qq(</style>\n));
	}
	push(@header, qq(</head>\n<body>\n));

	$footer = qq(</body>\n</html>\n);

	$this->{CONTENT}
		= join('', @header, @{$this->{BODY}}, $this->{KET}, $footer);
}

sub _push_text_pseudo_xhtml_au
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		COLOR => '',
		@_,
		);

	$this->_push_position_pseudo_xhtml_au($param{POSITION}, $param{COLOR});
	$this->_trans_string_html($param{STRING});
	push(@{$this->{BODY}}, ${$param{STRING}});
}

sub _push_anchor_pseudo_xhtml_au
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		URL => '',
		KEY => '',
		@_,
		);

	$this->_push_position_pseudo_xhtml_au($param{POSITION});
	$this->_trans_string_html($param{STRING});

	if ( $param{KEY} && $this->{BI}->{KEY}->[$param{KEY}] ) {
		push(@{$this->{BODY}},
			$this->{BI}->{KEY}->[$param{KEY}],
			qq(<a href="$param{URL}" accesskey="$param{KEY}">),
			qq(${$param{STRING}}</a>)
		);
	} else {
		push(@{$this->{BODY}}, qq(<a href="$param{URL}">${$param{STRING}}</a>));
	}
}

sub _push_mlink_pseudo_xhtml_au
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		MAIL => '',
		KEY => '',
		@_,
		);

	$this->_push_position_pseudo_xhtml_au($param{POSITION});
	$this->_trans_string_html($param{STRING});
	if ( $param{KEY} ) {
		push(@{$this->{BODY}},
			qq(<a href="mailto:$param{MAIL}" accesskey="$param{KEY}">),
			qq(${$param{STRING}}</a>)
		);
	} else {
		push(@{$this->{BODY}},
			qq(<a href="mailto:$param{MAIL}">),
			qq(${$param{STRING}}</a>)
			);
	}
}

sub _push_plink_pseudo_xhtml_au
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		PHONE => '',
		KEY => '',
		@_,
		);

	$this->_push_position_pseudo_xhtml_au($param{POSITION});
	$this->_trans_string_html($param{STRING});
	if ( $param{KEY} ) {
		push(@{$this->{BODY}},
			qq(<a href="wtai://wp/mc;$param{PHONE}" accesskey="$param{KEY}">),
			qq(${$param{STRING}}</a>)
		);
	} else {
		push(@{$this->{BODY}},
			qq(<a href="wtai://wp/mc;$param{PHONE}">),
			qq(${$param{STRING}}</a>)
			);
	}
}

sub _push_image_pseudo_xhtml_au
{
	my $this = shift;
	my %param = (
		POSITION => 'l',
		STRING => \'',
		URL => '',
		@_,
		);

	$this->_push_position_pseudo_xhtml_au($param{POSITION});
	$this->_trans_string_html($param{STRING});
	$this->_trans_image_extension(\$param{URL});
	${$param{STRING}} =~ s/"/&quot;/g;
	push(@{$this->{BODY}}, qq(<img src="$param{URL}"));
	${$param{STRING}} and push(@{$this->{BODY}}, qq( alt="${$param{STRING}}"));
	push(@{$this->{BODY}}, qq( />));
}

sub _push_hr_pseudo_xhtml_au
{
	my $this = shift;

	push(@{$this->{BODY}}, $this->{KET}, qq(<hr />\n));
	$this->{KET} = '';
}

sub _push_position_pseudo_xhtml_au
{
	my $this = shift;
	my ($position, $color) = @_;

	if ( $position eq 'l' ) {
		# AÚuȂ񂿂XHTMLvłfont^Og܂B߂łB
		push(@{$this->{BODY}}, $this->{KET});
		if ( $color ) {
			push(@{$this->{BODY}}, qq(<font color="$color">));
			$this->{KET} = "</font><br />\n";
		} else {
			$this->{KET} = "<br />\n";
		}
	} elsif ( $position eq 'c' ) {
		# AÚuȂ񂿂XHTMLvłcenter^Og܂B߂łB
		push(@{$this->{BODY}}, $this->{KET});
		if ( $color ) {
			push(@{$this->{BODY}},
				qq(<center style="color:$color;">));
		} else {
			push(@{$this->{BODY}}, qq(<center>));
		}
		$this->{KET} = "</center><br />\n";
	} elsif ( $position eq 'r' ) {
		push(@{$this->{BODY}}, $this->{KET});
		if ( $color ) {
			push(@{$this->{BODY}},
				qq(<span style="text-align:right;color:$color;">));
		} else {
			push(@{$this->{BODY}}, qq(<span style="text-align:right;">));
		}
		$this->{KET} = "</span><br />\n";
	} elsif ( $position eq 's' ) {
		# AÚuȂ񂿂XHTMLvłmarquee^Og܂B߂łB
		push(@{$this->{BODY}}, $this->{KET});
		if ( $color ) {
			push(@{$this->{BODY}},
				qq(<marquee style="color:$color;">));
		} else {
			push(@{$this->{BODY}}, qq(<marquee>));
		}
		$this->{KET} = "</marquee><br />\n";
	} elsif ( $position eq '^' ) {
		;
	}
}


#==========================================================================
#	[ wb_o ]
#==========================================================================
sub _print_http_header_html
{
	my $this = shift;

	$| = 1;
#	my $length = length($this->{CONTENT});
	print qq(Content-type: text/html$CRLF);
	$this->{PA}->{COOKIE}
		and print qq(Set-Cookie: ${$this->{PA}->{COOKIE}}$CRLF);
#	print qq(Content-length: $length$CRLF);
	print $CRLF;
}


sub _print_hdtp_header
{
	my $this = shift;

	$| = 1;
	print qq(Content-type: text/x-hdml;charset=Shift_JIS$CRLF);
	$this->{PA}->{COOKIE}
		and print qq(Set-Cookie: ${$this->{PA}->{COOKIE}}$CRLF);
	print $CRLF;
}

sub _print_http_header_onc
{
	my $this = shift;

	$| = 1;
	print qq(Content-Type: text/plain$CRLF$CRLF);
}


sub _print_http_header_xhtml
{
	my $this = shift;
	$this->_print_http_header_html(@_);
}


#==========================================================================
#	[ Locationwb_o ]
#==========================================================================
sub _print_location_header
{
	my $this = shift;

	my %param = (
		URL => '',
		@_,
		);

	if ( $this->{ML} eq 'ONC' ) {
		$param{URL} =~ s/^http://;
		$this->_trans_string_onc(\$this->{PE}->{JUMP_BODY});
		print <<"_EOF_";
Content-type: text/plain

From:$param{URL}
Subject:$this->{PE}->{JUMP_SUBJ}
Content-Type:Text/X-PmailDX

$this->{PE}->{JUMP_BODY}
_EOF_
	} else {
		print qq(Location:$param{URL}\n\n);
	}
	return 1;
}

sub _print_location_file
{
	my $this = shift;

	my %param = (
		URL => '',
		@_,
		);

	my $ret;
	if ( $this->{ML} eq 'ONC' && $param{URL} =~ /\.txt$/i ) {
		print qq(Content-type: text/plain\n\n);
		open(FILE, "<$param{URL}");
		print while <FILE>;
		close(FILE);
		$ret = 1;
	} elsif ( $this->{ML} eq 'HDML' && $param{URL} =~ /\.hdml$/i ) {
		print qq(Content-type: text/x-hdml;charset=Shift_JIS\n\n);
		open (FILE, "<$param{URL}");
		print while <FILE>;
		close FILE;
		$ret = 1;
	} elsif ( $param{URL} =~ /\.html?$/i ) {
		print qq(Content-type: text/html\n\n);
		open (FILE, "<$param{URL}");
		print while <FILE>;
		close FILE;
		$ret = 1;
	} else {
		$ret = 0;
	}

	return $ret;
}

#==========================================================================
#	[ 񒲐 ]
#==========================================================================
sub _trans_string_html
{
	my $this = shift;

	my $s = $_[0];
	$$s =~ s/&/&amp;/;
	$$s =~ s/</&lt;/;
	$$s =~ s/>/&gt;/;
}


sub _trans_string_hdml
{
	my $this = shift;

	my $s = $_[0];
	$$s =~ s/&/&amp;/g;
	$$s =~ s/</&lt;/g;
	$$s =~ s/>/&gt;/g;
	$$s =~ s/\$/&dol;/g;
}


sub _trans_string_onc
{
	my $this = shift;

	my $s = $_[0];
	$$s =~ s/</<</g;
}

sub _trans_string_xhtml
{
	my $this = shift;

	my $s = $_[0];
	$$s =~ s/&/&amp;/;
	$$s =~ s/</&lt;/;
	$$s =~ s/>/&gt;/;
}


#==========================================================================
#	[ C[Wt@Cgq ]
#==========================================================================
sub _trans_image_extension
{
	my $this = shift;

	my $s = $_[0];
	my $ext;
	foreach $ext (@{$this->{BI}->{IMG}}) {
		if ( $$s =~ /\.$ext$/i ) {
			return;
		}
	}
	$$s =~ s/(.+)\..*$/$1\.$this->{BI}->{IMG}->[0]/;
}

#==========================================================================
#	[  ]
#==========================================================================

#--------------------------------------------------------------------------
#	֐	_init
#	@\	IuWFNg̏
#		DISTINCTION_METHOD:	[ʕ@('host' or 'ua')
#			SET:	eݒli[nbṼt@X
#--------------------------------------------------------------------------
sub _init
{
	my $this = shift;
	my %param = (
		DISTINCTION_METHOD => 'ua',
		SET => {},
		@_,
		);

	$this->{BODY} = [];
	$this->{BI} = {};	# Brouser Info
	$this->{PA} = {};	# Page Attribute
	$this->{PE} = {};	# Page Extention
	$this->{SET} = {};	# Setting
	$this->{SET} = $param{SET};	# Setting
	$this->{BI}->{IMG} = [];

	$UserAgent = $ENV{HTTP_USER_AGENT};
	@UserAgent = split(/\//, $UserAgent);

	if ( $param{DISTINCTION_METHOD} eq 'host' ) {
		$this->_distinguish_by_host();
	} elsif ( $param{DISTINCTION_METHOD} eq 'ua' ) {
		$this->_distinguish_by_ua();
	}
}


#==========================================================================
#	[ [ ]
#==========================================================================

#--------------------------------------------------------------------------
#	֐	_distinguish_by_host
#	@\	REMOTE_HOSTɂ[
#		Ȃ
#--------------------------------------------------------------------------
sub _distinguish_by_host
{
	my $this = shift;
	my $rh = $ENV{REMOTE_HOST};

	if ( $rh =~ /\.(?:ezweb|ido)\.ne\.jp$/ ) {
		$this->_analyze_ezweb();
	} elsif ( $rh eq 'pdxcgw.pdx.ne.jp' ) {
		$this->_analyze_hlink();
	} elsif ( $rh =~ /\.docomo\.ne\.jp$/ ) {
		$this->_analyze_imode();
	} elsif ( $rh =~ /\.jp-[ckqt]\.ne\.jp$/ ) {
		$this->_analyze_jsky();
	} elsif ( $rh =~ /\.pipopa\.ne\.jp$/ ) {
		$this->_analyze_lmode();
	} else {
		$this->_analyze_other();
	}
}

#--------------------------------------------------------------------------
#	֐	_distinguish_by_ua
#	@\	HTTP_USER_AGENTɂ[
#		Ȃ
#--------------------------------------------------------------------------
sub _distinguish_by_ua
{
	my $this = shift;

	if ( $UserAgent =~ /^Mozilla\/3.0\(DDIPOCKET;/ ) {
		$this->_analyze_airhphone();
	} elsif ( $UserAgent[0] eq 'ASTEL' ) {
		$this->_analyze_doti();
	} elsif ( $UserAgent[0] =~ /UP\.Browser|OPWV/ ) {
		$this->_analyze_ezweb();
	} elsif ( $UserAgent[0] eq 'PDXGW' || $UserAgent[0] eq 'Ginga' ) {
		$this->{ANALYZE} = $this->_analyze_hlink();
	} elsif ( $UserAgent[0] eq 'DoCoMo' ) {
		$this->_analyze_imode();
	} elsif ( $UserAgent[0] eq 'J-PHONE' ) {
		$this->_analyze_jsky();
	} elsif ( $UserAgent[0] eq 'L-mode' ) {
		$this->_analyze_lmode();
	} else {
		$this->_analyze_other();
	}
}


#==========================================================================
#	[ [ ]
#==========================================================================

#--------------------------------------------------------------------------
#	֐	_analyze_airhphone
#	@\	AirH" PHONE[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_airhphone
{
	my $this = shift;

	$this->{SERVICE} = 'AIRHPHONE';
	$this->{ML} = 'CHTML';
	$this->{METHOD} = 'post';

	$this->{BI}->{ADKEY} = 'accesskey';
	$this->{BI}->{KEY} = [
		"\xF0\xBE",
		"\xF0\xBF",
		"\xF0\xC0",
		"\xF0\xC1",
		"\xF0\xC2",
		"\xF0\xC3",
		"\xF0\xC4",
		"\xF0\xC5",
		"\xF0\xC6",
		"\xF0\xC7",
		];
	$this->{BI}->{AUTO_TITLE} = 0;
	$this->{BI}->{IMG} = ['png', 'bmp', 'jpeg', 'jpg', 'gif' ];
	$this->_analyze_airhphone_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_doti
#	@\	hbgi[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_doti
{
	my $this = shift;

	$this->{SERVICE} = 'DOTI';
	$this->{ML} = 'CHTML';
	$this->{METHOD} = 'post';

	$this->{BI}->{ADKEY} = 'accesskey';
	$this->{BI}->{KEY} = [
		"\xF0\x40",
		"\xF0\x41",
		"\xF0\x42",
		"\xF0\x43",
		"\xF0\x44",
		"\xF0\x45",
		"\xF0\x46",
		"\xF0\x47",
		"\xF0\x48",
		"\xF0\x49",
		];
	$this->{BI}->{AUTO_TITLE} = 0;
	$this->{BI}->{IMG} = ['gif'];
	$this->_analyze_doti_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_ezweb
#	@\	EZweb[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_ezweb
{
	my $this = shift;

	$this->{SERVICE} = 'EZWEB';
	if ( $UserAgent[0] eq 'UP.Browser' ) {
		$this->_analyze_ezweb_hdml();
	} else {
		$this->_analyze_ezweb_xhtml();
	}
	$this->{PE}->{CARDKET} = '</DISPLAY>';
}

#--------------------------------------------------------------------------
#	֐	_analyze_ezweb_hdml
#	@\	EZweb[(HDML[)̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_ezweb_hdml
{
	my $this = shift;

	$this->{ML} = 'HDML';
	if ( $ENV{HTTP_X_UP_DEVCAP_SCREENCHARS} ) {
		$this->{BI}->{HR}
			= '-' x (split(/,/, $ENV{HTTP_X_UP_DEVCAP_SCREENCHARS}))[0];
	} else {
		$this->{BI}->{HR} = '------------';
	}
	$this->{BI}->{HR} .= "<BR>\n";

	if ( $ENV{HTTP_X_UP_DEVCAP_ISCOLOR} ) {
		$this->{BI}->{IMG} = ['png', 'bmp'];
	} else {
		$this->{BI}->{IMG} = ['bmp'];
	}
	$this->_analyze_ezweb_hdml_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_ezweb_xhtml
#	@\	EZweb[(WAP2.0[)̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_ezweb_xhtml
{
	my $this = shift;

	$this->{ML} = 'XHTML_AU';
	$this->{BI}->{KEY} = [
		qq(<img localsrc="325" />),
		qq(<img localsrc="180" />),
		qq(<img localsrc="181" />),
		qq(<img localsrc="182" />),
		qq(<img localsrc="183" />),
		qq(<img localsrc="184" />),
		qq(<img localsrc="185" />),
		qq(<img localsrc="186" />),
		qq(<img localsrc="187" />),
		qq(<img localsrc="188" />),
		];
	$this->_analyze_ezweb_xhtml_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_hlink
#	@\	H"Link[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_hlink
{
	my $this = shift;

	$this->{SERVICE} = 'HLINK';
	$this->{ML} = 'ONC';

	$UserAgent[1] =~ /1.0 \(([\w=;]+)\)$/;
	my @param = split(/;/, $1);
	foreach ( @param ) {
		my($name, $value) = split(/=/, $_);
		$this->{BI}->{$name} = $value;
	}

	if ( $this->{BI}->{GI} >= 2 ) {
		$this->{BI}->{IMG} = ['bmp', 'jpg', 'jpeg'];
	} else {
		$this->{BI}->{IMG} = ['bmp'];
	}

	$this->{BI}->{TX} ||= 6;
	$this->{BI}->{HR} = ('|' x $this->{BI}->{TX}) . "\n";
	$this->{BI}->{FROM} = qq(//$ENV{SERVER_NAME}$ENV{SCRIPT_NAME});

	$this->{PE}->{JUMP_SUBJ} = 'Jump!';
	$this->{PE}->{JUMP_BODY} = 'xʘb{^ĉB';
	$this->{PE}->{ADD} = [];
	$this->{PE}->{SEL} = [];
	$this->{PE}->{KEY} = 100;
	$this->_analyze_hlink_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_imode
#	@\	i-mode[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_imode
{
	my $this = shift;

	$this->{SERVICE} = 'IMODE';
	$this->{ML} = 'CHTML';
	$this->{METHOD} = 'post';

	$this->{BI}->{ADKEY} = 'accesskey';
	$this->{BI}->{KEY} = [
		"\xF9\x90",
		"\xF9\x87",
		"\xF9\x88",
		"\xF9\x89",
		"\xF9\x8A",
		"\xF9\x8B",
		"\xF9\x8C",
		"\xF9\x8D",
		"\xF9\x8E",
		"\xF9\x8F",
		];
	$this->{BI}->{AUTO_TITLE} = 0;
	$this->{BI}->{IMG} = ['gif'];	# ()JPEGΉ̂Œ
	$this->_analyze_imode_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_jsky
#	@\	J-SKY[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_jsky
{
	my $this = shift;

	$this->{SERVICE} = 'JSKY';
	$this->{ML} = 'CHTML';
	if ( $UserAgent[1] <= 2 ) {
		$this->{METHOD} = 'get';
		$this->{BI}->{ADKEY} = 'directkey';
		$this->{BI}->{KEY} = [];
		$this->{BI}->{AUTO_TITLE} = 1;
	} else {
		$this->{METHOD} = 'get';
		$this->{BI}->{ADKEY} = 'nonumber directkey';
		$this->{BI}->{KEY} = [
			"\e\$FE\x0F",
			"\e\$F<\x0F",
			"\e\$F=\x0F",
			"\e\$F>\x0F",
			"\e\$F?\x0F",
			"\e\$F@\x0F",
			"\e\$FA\x0F",
			"\e\$FB\x0F",
			"\e\$FC\x0F",
			"\e\$FD\x0F",
		];
		$this->{BI}->{AUTO_TITLE} = 0;
	}
	$this->{BI}->{IMG} = ['png'];	# ()JPEGΉ̂Œ
	$this->_analyze_jsky_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_lmode
#	@\	L-mode[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_lmode
{
	my $this = shift;

	$this->{SERVICE} = 'LMODE';
	$this->{ML} = 'CHTML';
	$this->{METHOD} = 'post';

	$this->{BI}->{ADKEY} = 'accesskey';
	$this->{BI}->{KEY} = [
		"\xF9\x90",
		"\xF9\x87",
		"\xF9\x88",
		"\xF9\x89",
		"\xF9\x8A",
		"\xF9\x8B",
		"\xF9\x8C",
		"\xF9\x8D",
		"\xF9\x8E",
		"\xF9\x8F",
		];
	$this->{BI}->{AUTO_TITLE} = 0;
	$this->{BI}->{IMG} = ['gif'];	# ()v
	$this->_analyze_lmode_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_other
#	@\	P[^C[ȊỎ
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_other
{
	my $this = shift;

	my $ua = "PalmScape|sharp pda browser|Windows CE|WorldTALK|Xiino|NetFront";
	if ( $UserAgent =~ /$ua/ ) {
		$this->_analyze_other_pda();
	} else {
		$this->_analyze_other_pc();
	}
	$this->{ML} = 'HTML';
	$this->{METHOD} = 'post';

	$this->{BI}->{ADKEY} = '';
	$this->{BI}->{KEY} = [];
	$this->{BI}->{AUTO_TITLE} = 0;
	$this->{BI}->{IMG} = ['bmp', 'gif', 'jpg', 'jpeg', 'png'];
}

#--------------------------------------------------------------------------
#	֐	_analyze_other_pda
#	@\	PDA[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_other_pda
{
	my $this = shift;

	$this->{SERVICE} = 'PDA';
	$this->_analyze_other_pda_ex();
}

#--------------------------------------------------------------------------
#	֐	_analyze_other_pc
#	@\	PC[̉
#		Ȃ
#--------------------------------------------------------------------------
sub _analyze_other_pc
{
	my $this = shift;

	$this->{SERVICE} = 'UNDEF';
	$this->_analyze_other_pc_ex();
}

sub _analyze_doti_ex{}
sub _analyze_airhphone_ex{}
sub _analyze_ezweb_hdml_ex{}
sub _analyze_ezweb_xhtml_ex{}
sub _analyze_hlink_ex{}
sub _analyze_imode_ex{}
sub _analyze_jsky_ex{}
sub _analyze_lmode_ex{}
sub _analyze_other_pda_ex{}
sub _analyze_other_pc_ex{}

1;

__END__
